static char *help_text[] =
{
  "                     --- Gnuscope ---\n\nIndex:\n\n
I: History\nII: Changes from prior versions of scope fit\nIII:  File Types\n  A:  Histogram types\n  B:  Density Plot types\n  C:  Matrix types\n  D:  Command Files\n  E:  Setup Files\n  F:  Master Setup Files\nIV:  Functions\n  A:  File\n  B:  Manipulate\n  C:  Display\n  D:  Analysis\n  E:  Sort\n  F:  Fits\n  G:  2D Histograms\n  H:  Matrix\n  I:  Degraded\n\nI: History:\nGnuscope is the latest evolution of programs based on scope fit which has been maintained and enhanced by Sam Tabor and his students.  Gnuscope was written by and is currently maintained by John Pavan (pavan@nucmar.physics.fsu.edu).  Since this type of software is constantly in developement there may be bugs and there may be features added.  Please check the recent changes list at startup for recent developments.\n\nFuture plans include integrated Lineshape fitting, but this is unlikely until we do more DSAM lifetime measurements.  Additionally, there may eventually be support for hypercubes similar to those from Radware and sorting from databases similar to Blue.  Both hypercube support and database support are unlikely until we have a reason to add them (eg another GAMMASPHERE or EUROSPHERE or GRETA run).\n\nII:  Changes from Prior versions of Scope Fit\n
\nThe most noticable change from prior versions of Scope Fit is that Gnuscope no longer relies on Tektronix 4010 emulation for graphical output, but there are other large differences.  For instance, Gnuscope uses dynamic memory management so the memory for a particular structure (histogram, density plot, or matrix) is allocated at the time it is needed.  This allows a single program to support integer square matricies, integer triangluar matricies, floating point square matrices, and floating point triangular matricies without swamping the computer.  Additionally, gnuscope can read multiple file formats, such as .spk files from DAMM, .spe files from Radware, .NSM files from prior versions of Scope Fit, .nsm files from the online version of Scope Fit, simple lists of x,y data for generic input, .big files for 2D histograms, .ede files for multiple 2D histograms, and both versions of .twd and .sqr files.  Another major difference is that Gnuscope functions can be accessed through pulldown menues.  Prior versions of scope fit only offered access to functions via hotkeys.  In short there are many differences between Gnuscope and prior versions of Scope Fit.\n\nIII:  File Types\nFile types are automatically detected by the Read option under the File menu.  This is acomplished by a combination of examining the file extention and the contents of the file.  If there is a problem with reading a file you know to be of a particular type please insure that the file extention is correct (it is case sensative).  A:  Histogram types\n    1:  Binary NSM (.NSM)\n      The binary NSM format is and was the standard for the Scope Fit class of programs.  It can be used to store information about multiple 1D histograms including a title and date.\n    2:  ASCII NSM (.nsm)\n      The ASCII NSM format is used by older versions of the online version of scope fit.\n    3:  Binary SPK (.spk)\n      The binary version of SPK files is used by DAMM and other Oak Ridge software for storing 1D histograms.\n    4:  ASCII SPK or SPE (.spe)\n      SPE files are used for 1D histograms by Radware.\n    5:  General ASCII (.txt)\n      Gnuscope can input generic data from an ASCII file containing 2 columns of numbers.  The first column must contain the x coordinate, the second the y coordinate.  If the x cooridinate ever drops Gnuscope will interpret this as a second plot.\n  B:  Density Plot Types\n    1:  BIG file (.big)\n      BIG files are ASCII based, they begin with 1 line containing the x and y dimentions, followed by a bunch of lines containing the z information for 10 x and y coordinates.  They are very innefficient in terms of disk space.\n    2:  EDE file (.ede)\n      EDE files are the alternative to BIG files for storing Density plot information in Gnuscope.  The main differences are that they are stored in binary, and that they can contain more than 1 2D histogram.\n  C:  Matrix Types\n    There are 4 matrix types with two file extentions.  The man differences between the types consist of the format for the information (float or short int), and if the matrix is symmetric (.twd) or not(.sqr).\n  D:  Command Files\n    Command files (.cmd) have the following options:\n    in <filename>   Read a file\n    mark <channe> Put a mark in a channel\n    cal <histogram> <a><b><c> set the calibration for histogram\n    background <counts>   Set the background to counts\n    sum <channel1> <channel2> <background>  Sums between channel1 and channel2\n    gauss <channel1> <channel2> <background>   gaussina fit between channel1 and channel2 using background\n    doublegauss <minchan> <maxchan> <peak1> <peak2> <width1> <width2> <background>  Double gauss fit\n    fixedFWHMgauss <minchan> <maxchan> <FWHM> <background>    Fixed width gauss fit\n    expfit <minchan> <maxchan>  exponential fit\n    sort clear    Clears the sorting options\n    sort output tac    Toggles TAC output on\n    sort output histogram    Toggles histogram output on\n    sort output part <opt telescopezoom>  Toggles 2D histogram output on, optionally inputs a zoom factor\n    sort output twd    Toggles gamma-gamma symmetric matrix output on\n    sort output ggsqr <filename>   Toggles assymetric matrix output on, <filename> should contain information about which ADCs go on which axes.\n    sort output pgsqr <partfincal> toggles particle-gamma matrix output on.  Optionally takes the final calibration of the particles.\n    sort output pairsqr <filename>  Toggle pair matrix output on.  <filename> should be contain information about the pairs.\n    sort gate tac   Toggle tac gating on.\n    sort gate part <opt filename>   Toggle particle gating on.  Optionally inputs a gate file.\n    sort gate gamma <minchan> <maxchan>   require a gamma ray between minchan and maxchan\n    sort gate gamma <filename>   require a gamma ray between a list of minchans and maxchans from <filename>.\n    sort gate veto <filename>   Toggle veto gating on.  <filename> contains the veto adcs and channels.\n    sort gate requires <filename>    Toggle requires gating on.  <filename> contains the adcs and channels which are required.\n    sort gate selfsuppressclovers   Toggles clover self supression on\n    sort gate minmultiplicity <minmultiplicity>   Toggles minimum clover multiplicity on.\n    sort sort   sorts\n.
};
